import { LRParser } from '@lezer/lr';
import { NodeProp } from '@lezer/common';
import { LRLanguage, indentNodeProp, delimitedIndent, foldNodeProp, foldInside, LanguageSupport } from '@codemirror/language';
import { styleTags, tags } from '@codemirror/highlight';
import { completeFromList } from '@codemirror/autocomplete';

// This file was generated by lezer-generator. You probably shouldn't edit it.
const parser = LRParser.deserialize({
  version: 13,
  states: "!|QYQPOOOhQPO'#CfO!VQPO'#CeOOQO'#Cj'#CjQYQPOOOYQPO,58|OYQPO,58|OYQPO,58|OOQO,59P,59PO!hQPO,59POOQO-E6d-E6dOOQO1G.h1G.hO#eQPO1G.hO#lQPO1G.hOOQO1G.k1G.k",
  stateData: "#s~O]OSPOS~ORROSROTROWQO~O_TO`UOaVORYXSYXTYXWYXZYXVYX~ORROSROTROVWOWQO~ORROSROTROV^OWQO~O_TORUiSUiTUiWUiZUiaUiVUi~O`Ui~P!yO`UO~P!yO",
  goto: "!S_PPPPPP`PP`iPPPs_ROQSTUVXQSOQXQTYSXWPOQSXQZTQ[UR]V",
  nodeNames: "⚠ LineComment Query Identifier String Boolean BooleanExpression ) ( Application",
  maxTerm: 17,
  nodeProps: [
    [NodeProp.openedBy, 7,"("],
    [NodeProp.closedBy, 8,")"]
  ],
  skippedNodes: [0,1],
  repeatNodeCount: 1,
  tokenData: "(p~RbXY!ZYZ!Z]^!Zpq!Zrs!lst#Zxy#iyz#n}!O#s!Q![#s!]!^$X!c!d$d!d!p#s!p!q&Q!q!r'n!r!}#s#R#S#s#T#o#s~!`S]~XY!ZYZ!Z]^!Zpq!Z~!oTOr!lrs#Os#O!l#O#P#T#P~!l~#TOS~~#WPO~!l~#^Q#Y#Z#d#h#i#d~#iOT~~#nOW~~#sOV~~#xTR~}!O#s!Q![#s!c!}#s#R#S#s#T#o#s~$^QP~OY$XZ~$X~$iVR~}!O#s!Q![#s!c!p#s!p!q%O!q!}#s#R#S#s#T#o#s~%TVR~}!O#s!Q![#s!c!f#s!f!g%j!g!}#s#R#S#s#T#o#s~%qT_~R~}!O#s!Q![#s!c!}#s#R#S#s#T#o#s~&VVR~}!O#s!Q![#s!c!q#s!q!r&l!r!}#s#R#S#s#T#o#s~&qVR~}!O#s!Q![#s!c!v#s!v!w'W!w!}#s#R#S#s#T#o#s~'_Ta~R~}!O#s!Q![#s!c!}#s#R#S#s#T#o#s~'sVR~}!O#s!Q![#s!c!t#s!t!u(Y!u!}#s#R#S#s#T#o#s~(aT`~R~}!O#s!Q![#s!c!}#s#R#S#s#T#o#s",
  tokenizers: [0],
  topRules: {"Query":[0,2]},
  tokenPrec: 0
});

const simpleBooleanLanguage = LRLanguage.define({
    parser: parser.configure({
        props: [
            indentNodeProp.add({
                Application: delimitedIndent({ closing: ")", align: false })
            }),
            foldNodeProp.add({
                Application: foldInside
            }),
            styleTags({
                "AND OR NOT": tags.operatorKeyword,
                Operator: tags.operator,
                Identifier: tags.variableName,
                Boolean: tags.bool,
                String: tags.string,
                LineComment: tags.lineComment,
                "( )": tags.paren
            })
        ]
    }),
    languageData: {
        commentTokens: { line: ";" }
    }
});
/**
 * Customizable autocomplete function for lang-simpleboolean
 * @param completeFromListParameter Completion[]
 * @returns CodeMirror autocomplete
 */
const simpleBooleanCompletion = (completeFromListParameter = []) => simpleBooleanLanguage.data.of({
    autocomplete: completeFromList(completeFromListParameter.concat([
        { label: "AND", type: "keyword" },
        { label: "OR", type: "keyword" },
        { label: "NOT", type: "keyword" }
    ]))
});
function simpleboolean() {
    return new LanguageSupport(simpleBooleanLanguage);
}

export { simpleBooleanCompletion, simpleBooleanLanguage, simpleboolean };
